# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.category import Category  # noqa: F401,E501
from swagger_server.models.pet import Pet  # noqa: F401,E501
from swagger_server.models.tag import Tag  # noqa: F401,E501
from swagger_server import util


class Cat(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, id: int=None, category: Category=None, name: str=None, photo_urls: List[str]=None, tags: List[Tag]=None, status: str=None, hunts: bool=None, age: int=None):  # noqa: E501
        """Cat - a model defined in Swagger

        :param id: The id of this Cat.  # noqa: E501
        :type id: int
        :param category: The category of this Cat.  # noqa: E501
        :type category: Category
        :param name: The name of this Cat.  # noqa: E501
        :type name: str
        :param photo_urls: The photo_urls of this Cat.  # noqa: E501
        :type photo_urls: List[str]
        :param tags: The tags of this Cat.  # noqa: E501
        :type tags: List[Tag]
        :param status: The status of this Cat.  # noqa: E501
        :type status: str
        :param hunts: The hunts of this Cat.  # noqa: E501
        :type hunts: bool
        :param age: The age of this Cat.  # noqa: E501
        :type age: int
        """
        self.swagger_types = {
            'id': int,
            'category': Category,
            'name': str,
            'photo_urls': List[str],
            'tags': List[Tag],
            'status': str,
            'hunts': bool,
            'age': int
        }

        self.attribute_map = {
            'id': 'id',
            'category': 'category',
            'name': 'name',
            'photo_urls': 'photoUrls',
            'tags': 'tags',
            'status': 'status',
            'hunts': 'hunts',
            'age': 'age'
        }
        self._id = id
        self._category = category
        self._name = name
        self._photo_urls = photo_urls
        self._tags = tags
        self._status = status
        self._hunts = hunts
        self._age = age

    @classmethod
    def from_dict(cls, dikt) -> 'Cat':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The Cat of this Cat.  # noqa: E501
        :rtype: Cat
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> int:
        """Gets the id of this Cat.


        :return: The id of this Cat.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """Sets the id of this Cat.


        :param id: The id of this Cat.
        :type id: int
        """

        self._id = id

    @property
    def category(self) -> Category:
        """Gets the category of this Cat.


        :return: The category of this Cat.
        :rtype: Category
        """
        return self._category

    @category.setter
    def category(self, category: Category):
        """Sets the category of this Cat.


        :param category: The category of this Cat.
        :type category: Category
        """

        self._category = category

    @property
    def name(self) -> str:
        """Gets the name of this Cat.


        :return: The name of this Cat.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name: str):
        """Sets the name of this Cat.


        :param name: The name of this Cat.
        :type name: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def photo_urls(self) -> List[str]:
        """Gets the photo_urls of this Cat.


        :return: The photo_urls of this Cat.
        :rtype: List[str]
        """
        return self._photo_urls

    @photo_urls.setter
    def photo_urls(self, photo_urls: List[str]):
        """Sets the photo_urls of this Cat.


        :param photo_urls: The photo_urls of this Cat.
        :type photo_urls: List[str]
        """
        if photo_urls is None:
            raise ValueError("Invalid value for `photo_urls`, must not be `None`")  # noqa: E501

        self._photo_urls = photo_urls

    @property
    def tags(self) -> List[Tag]:
        """Gets the tags of this Cat.


        :return: The tags of this Cat.
        :rtype: List[Tag]
        """
        return self._tags

    @tags.setter
    def tags(self, tags: List[Tag]):
        """Sets the tags of this Cat.


        :param tags: The tags of this Cat.
        :type tags: List[Tag]
        """

        self._tags = tags

    @property
    def status(self) -> str:
        """Gets the status of this Cat.

        pet status in the store  # noqa: E501

        :return: The status of this Cat.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status: str):
        """Sets the status of this Cat.

        pet status in the store  # noqa: E501

        :param status: The status of this Cat.
        :type status: str
        """
        allowed_values = ["available", "pending", "sold"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def hunts(self) -> bool:
        """Gets the hunts of this Cat.


        :return: The hunts of this Cat.
        :rtype: bool
        """
        return self._hunts

    @hunts.setter
    def hunts(self, hunts: bool):
        """Sets the hunts of this Cat.


        :param hunts: The hunts of this Cat.
        :type hunts: bool
        """

        self._hunts = hunts

    @property
    def age(self) -> int:
        """Gets the age of this Cat.


        :return: The age of this Cat.
        :rtype: int
        """
        return self._age

    @age.setter
    def age(self, age: int):
        """Sets the age of this Cat.


        :param age: The age of this Cat.
        :type age: int
        """

        self._age = age
